
import java.util.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.*;
import java.applet.*;
import java.awt.event.*;


public class CatalogEditor extends JFrame {


	JButton   myAddButton =    new JButton("Add");
	JButton   myDeleteButton = new JButton("Delete");
	JList     myList =         new JList();
	JTextArea myTextArea =     new JTextArea();
	JPanel    myButtonPanel =  new JPanel();
	JPanel    myListButPanel = new JPanel();
	JPanel    myAreaPanel =    new JPanel();

	public CatalogEditor(final ProductCatalog catalog) {
		super("Product Editor");
		setSize(400,300);


		/* ALL CALLBACK FUNCTIONS FOR EVENT-HANDLING */
		myAddButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				
				// SWING Add - Button
				ProductCreator new_product = new ProductCreator(catalog, myList);
				new_product.show();
			}
		} );
		myDeleteButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if(!myList.isSelectionEmpty()){
					delItem(catalog);
					myDeleteButton.setEnabled(false);
				}
			}
		} );
		myList.addListSelectionListener(new ListSelectionListener() {
			public void valueChanged(ListSelectionEvent e) {
				if(!myList.isSelectionEmpty()){
				myTextArea.setText((catalog.getProduct((String)myList.getSelectedValue()
					)).getDescription());
				myDeleteButton.setEnabled(true);
				}
				else {
					myDeleteButton.setEnabled(false);
					myTextArea.setText("");
				}
			}
		} );


		// SWING ------------
		myDeleteButton.setEnabled(false);
		myButtonPanel.setLayout(new GridLayout(2,1));
		myButtonPanel.setSize(100, 200);
		myButtonPanel.add(myAddButton, BorderLayout.NORTH);
		myButtonPanel.add(myDeleteButton, BorderLayout.SOUTH);

		myAreaPanel.setLayout(new GridLayout(1,1));
		myAreaPanel.add(myTextArea, BorderLayout.CENTER);

		// LIST -------------
		myList.setListData(catalog.getPIDs());

		myListButPanel.setLayout(new GridLayout(1,2));
		myListButPanel.add(myList);
		myListButPanel.add(myButtonPanel);

		getContentPane().setLayout(new GridLayout(2,1));
		getContentPane().add(myListButPanel);
		getContentPane().add(myAreaPanel);

	}

	public int getListSize() {
		ListModel model = (ListModel) myList.getModel();
		return model.getSize();
	}
	public void delItem(ProductCatalog catalog) {
		Product del;
		del = catalog.getProduct((String)myList.getSelectedValue());
		catalog.removeProduct(del);
		myList.setListData(catalog.getPIDs());
		myTextArea.setText("");
	}	
}





