import java.lang.*;
import junit.framework.*;

//! \class TEST CLASS CatalogEditorTest
public class CatalogEditorTest extends TestCase {

	private ProductCatalog catalog;
	
	//! the one and only editor
	private CatalogEditor editor;


	//! constructor of this test-class
	public CatalogEditorTest(String name) {
		super(name);
	}


	/*
	 * 	Test, ob Delete-Button richtig angezeigt wird
	 * 	(mit Test der Enable/Disable - Funktion)
	 */
	 
	public void testDeleteButton (){
		
			assertTrue(editor.myDeleteButton.isShowing());
			assertEquals("Delete", editor.myDeleteButton.getText());
			
			assertTrue(!editor.myDeleteButton.isEnabled());
			
			try { new Thread().sleep(5000); } catch (InterruptedException e) {}
			
			editor.myList.setSelectedIndex(0);
			assertTrue(editor.myDeleteButton.isEnabled());

			try { new Thread().sleep(5000); } catch (InterruptedException e) {}
			
			editor.myList.clearSelection();
			
			try { new Thread().sleep(5000); } catch (InterruptedException e) {}
			
			assertTrue(!editor.myDeleteButton.isEnabled());
	}


	/*
	 * 	Test, ob die Produkte aus der Datenstruktur und der Liste geloescht werden
	 */

	public void testDeleteProduct() {
		
		try { new Thread().sleep(5000); } catch (InterruptedException e) {}
		
		editor.myList.setSelectedIndex(2);
		Product del = new Product((String)editor.myList.getSelectedValue());
		del = catalog.getProduct((String)editor.myList.getSelectedValue());
		
		try { new Thread().sleep(5000); } catch (InterruptedException e) {}
		
		editor.myDeleteButton.doClick();
			
		try { new Thread().sleep(5000); } catch (InterruptedException e) {}

		assertEquals(2, editor.getListSize());
		
		assertEquals(2, catalog.getProducts().size());
		assertTrue(!catalog.getProducts().contains(del));
	}

	/*
	 * 	Test, ob die Produkte in die Liste eingetragen werden
	 */
	
	public void testProductList() {
		assertTrue(editor.myList.isShowing());
		assertEquals(3, editor.getListSize());
		
		Product product4 = new Product("0004");
		product4.setDescription("Mousepad");
		catalog.addProduct(product4);
		
		try { new Thread().sleep(5000); } catch (InterruptedException e) {}

		editor.myList.setListData(catalog.getPIDs());
		assertEquals(4, editor.getListSize());
	}


	//! for each test one window
	protected void setUp() {

		//catalog filling with products
		Product product1 = new Product("0001");
		product1.setDescription("Monitor");
		catalog = new SimpleProductCatalog();
		catalog.addProduct(product1);

		Product product2 = new Product("0002");
		product2.setDescription("Tastatur");
		catalog.addProduct(product2);

		Product product3 = new Product("0003");
		product3.setDescription("Mouse");
		catalog.addProduct(product3);

		//main editor
		editor = new CatalogEditor(catalog);
		editor.show();
	}
	
	protected void tearDown() {
		//editor.dispose();
	}


}

